# -*- coding: utf-8 -*-

"""A collection of functions that is used by blamlib itself"""

import sys
import xml.dom.minidom as minidom

def xml_get_text( xmlobj, tag_name ):
    """This function is semi-special, and will only return the text from
    the first tag with that name"""

    if xmlobj.getElementsByTagName( tag_name )[0].firstChild == None:
        return None # No text
    return xmlobj.getElementsByTagName( tag_name )[0].firstChild.nodeValue

def test_case( test, vars, wanted_result = None, no_specific = False,
               traceback = False ):
    """Evals test, if no_specific is False the result is compared with
    wanted_result, if they match we return True.

    If no_specific is True we return True if no error happened.

    If traceback is True we also print that on errors"""

    ret = None
        
    try:
        ret = eval( test, vars )
        
    except:
        err = sys.exc_info()
        print "Error in %s\ntype: %s, %s" %( test, err[0], err[1] )

        if traceback:
            print err[2]

        #print "FAIL    %s" % test
        return False

    if no_specific:
        print "OK    %s -> %s" %( test, ret )
        return True

    if str( ret ) == str( wanted_result ) and \
            type( ret ) == type( wanted_result ):
        print "OK    %s -> %s" %( test, ret )
        return True

    else:
        print "FAIL  %s -> %s" %( test, ret )
        return False
