#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys
from time import ctime
from blamlib.web import Kakwiki

"""A simple example for kakwiki module"""

if len( sys.argv ) == 1:
    print "kakwiki-remote.py"
    print
    print "Usage: kakwiki.py command [argument]"
    print
    print "Commands:"
    print "ls               - lists all page names"
    print "read [page name] - downloads page and print it"
    print
    exit()

simp = Kakwiki( "http://kakor.chebab.com/" )
simp.auth( "user", "password" ) # auth

if sys.argv[1] == 'ls' or sys.argv[1] == 'list':
    for x in simp.list().items():
        spaces = 30 - len( unicode( x[0], 'utf-8' ) )

        if spaces < 1:
            space = 1
        
        n_time = ctime( float( x[1][1] ) )
        print x[0] + ( " " * spaces ) +"%d\t%s" %( x[1][0], n_time )

elif sys.argv[1] == 'read' and len( sys.argv ) == 3:
    data = simp.read( sys.argv[2] )

    if data == None:
        print "No such page as %s" % sys.argv[2]
        exit( 1 )
    elif data == "LOCKED":
        print "Page %s requires authentication" % sys.argv[2]
        exit( 1 )

    print data
        
